/*  gtkcutlass-callbacks - the callbacks for the gui.  the real guts are going
to be elsewhere

(c) 2004 John Schweitzer (thanatos@hoodlum.org)
*/

#include <stdlib.h>

/* #include <gtk/gtk.h>
		#include <glade/glade.h>
		#include <glib.h>
		#include <gtkcutlass-utilities.h
 
*/

#include <gtkcutlass.h>

void on_TextConnectButton_clicked ( GtkWidget *widget, gpointer user_data )
{
    if ( get_treeview_selection_name() == NULL )
    {
        send_statusbar_message( "meh", "Nothing Selected" );
        return ;
    }
    TextConnect();
};


void on_save2_activate ( GtkWidget *widget, gpointer user_data )
{
    on_save1_activate ( widget, user_data );
};

void on_delete2_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
    g_print ( "delete2 called\n" );
};

void on_save1_activate ( GtkWidget *widget, gpointer user_data )
{
    extern gui_status * currentstatus;

    if ( save_user_info() != 0 )
        g_warning( "Couldn't save user info ...\n" );
    if ( save_contact_list() != 0 )
        g_warning( "Couldn't save contact info ... \n" );
    if ( save_user_key() != 0 )
        g_warning( "Couldn't save user private key ... \n" );
    currentstatus->unsavedchanges = FALSE;
};

void on_delete1_activate ( GtkWidget *widget, gpointer user_data )
{
    // This is the delete from main menu->edit->delete
    NotImplemented( widget );
    g_print ( "delete1 called\n" );
};

void on_AddContactButton_clicked ( GtkWidget *widget, gpointer user_data )
{
    on_new_contact1_activate ( widget, user_data );  // what the hell. Call the
    // other one.  no need in
    // creating more (perhaps
    // unnecessary) cruft
};

void on_RemoveContactButton_clicked ( GtkWidget *widget, gpointer user_data )
{
	extern gui_status *currentstatus;
	extern user_info *userstuff;
	gchar *contactname=NULL;
	contact_info *ci;
	GtkTreeIter target;
	GtkTreeView *gtkt;
	GtkTreeStore *treestore;

	contactname = get_treeview_selection_name();
	if (contactname == NULL)
	{
		send_statusbar_message ("meh","no contact selected");
		return;
	}
	ci = get_contact_from_name ( contactname );
	if (ci == NULL)
	{
		send_statusbar_message ("meh","no contact selected");
		return;
	}
	gtkt = currentstatus->Tree;
	treestore = GTK_TREE_STORE( gtk_tree_view_get_model ( gtkt ) );
	target = get_tree_iter_name ( contactname );
	gtk_tree_store_remove ( treestore, &target );
	userstuff->contacts = g_slist_remove ( userstuff->contacts, (gconstpointer) ci );
	contact_info_destroy ( ci );
	currentstatus->unsavedchanges=FALSE;
	save_contact_list();
	g_free (contactname);
};

void on_quit2_activate ( GtkWidget *widget, gpointer user_data )
{
    on_MainWinQuitbutton_clicked ( widget, user_data );
};

void on_quit1_activate ( GtkWidget *widget, gpointer user_data )
{
    on_MainWinQuitbutton_clicked ( widget, user_data );
};

void on_cut2_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void on_about2_activate ( GtkWidget *widget, gpointer user_data )
{
    AboutBox( GTKC_ABOUTMESSAGE );
};

void on_cut1_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void on_about1_activate ( GtkWidget *widget, gpointer user_data )
{
    AboutBox( GTKC_ABOUTMESSAGE );
};


void on_open2_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void on_paste2_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void on_open1_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void on_paste1_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void on_new2_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void on_save_as2_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void on_save_as1_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void on_SendFileButton_clicked ( GtkWidget *widget, gpointer user_data )
{
    gchar * contactname;
    conv_conn *cc;

    contactname = get_treeview_selection_name ();
    if ( contactname == NULL )
        return ;

    cc = ( conv_conn * ) get_conversation_from_name ( contactname );
    if ( cc == NULL )
    {
        tellem ( "Not Connected" );
    }

    // send the freekin file now.

    g_free ( contactname );
};

void on_mainwin_stopaudio_button_clicked ( GtkWidget *widget, gpointer user_data )
{
    extern user_info * userstuff;

    if ( cutlass_audio_disconnect_all( userstuff->cutlass_info ) != 0 )
        g_warning ( "couldn't stop all audio" );
    return ;
};

void on_new_contact1_activate ( GtkWidget *widget, gpointer user_data )
{
	run_newcontact_window(widget,user_data);
};

void on_new_group1_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void on_copy2_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void on_copy1_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void on_GTKCutlassMainWin_delete_event ( GtkWidget *widget, gpointer user_data )
{
    on_MainWinQuitbutton_clicked ( widget, user_data );
};

void on_GTKCutlassMainWin_destroy_event( GtkWidget *widget, gpointer user_data )
{
    on_MainWinQuitbutton_clicked ( widget, user_data );
};

void on_TextConversationWindow_destroy_event( GtkWidget *widget, gpointer user_data )
{
    // these should include shutting down the conversation too.
    gtk_widget_destroy( widget );
};

void on_TextConversationWindow_delete_event( GtkWidget *widget, gpointer user_data )
{
    // these should include shutting down the conversation too.
    gtk_widget_destroy( widget );
};

void on_MainWinQuitbutton_clicked ( GtkWidget *widget, gpointer user_data )
{
    extern gui_status * currentstatus;
    extern user_info *userstuff;
    if ( currentstatus->unsavedchanges )
        if ( YesNo( widget, "There are unsaved changes, really quit?" ) == GTK_RESPONSE_YES )
        {
            user_info_destroy( userstuff );
            gtk_main_quit();
        }
    if ( currentstatus->activeconversation )
        if ( YesNo( widget, "There is at least one active conversation, really quit?" ) == GTK_RESPONSE_YES )
        {
            user_info_destroy( userstuff );
            gtk_main_quit();
        }
    if ( ( currentstatus->activeconversation == FALSE ) && ( currentstatus->unsavedchanges == FALSE ) )
    {
        user_info_destroy( userstuff );
        gtk_main_quit();
    }
};


void on_help_me1_activate ( GtkWidget *widget, gpointer user_data )
{
    NotImplemented( widget );
};

void send_statusbar_message ( gchar *description, gchar *message )
{
    GtkStatusbar * sb;
    guint contextid = 0;

    extern gui_status *currentstatus;

    if ( currentstatus == NULL )
        return ;
    if ( message == NULL )
        return ;
    if ( description == NULL )
        return ;

    sb = ( GtkStatusbar * ) glade_xml_get_widget ( currentstatus->MainWinXML, "statusbar1" );
    if ( sb == NULL )
        g_warning ( "cannot find statusbar\n" );

    contextid = gtk_statusbar_get_context_id( sb, description );

    gtk_statusbar_push( sb, contextid, message );
}

void on_mainwin_connect_button_clicked ( GtkWidget *widget, gpointer user_data )
{
    extern gui_status * currentstatus;
    contact_info *ci;

    ci = get_contact_from_name ( get_treeview_selection_name () );
    if ( ci == NULL )
    {
        send_statusbar_message ( "meh", "No contact selected" );
        return ;
    }

    currentstatus->something_selected = TRUE;

    // make the entry

    if ( connect_to_contact ( ci ) != 0 )
    {
        tellem ( "Error Connecting to contact" );
        g_warning( "Error Connecting to contact" );
        return ;
    }
}

void on_user_prefrences1_activate ( GtkWidget *widget, gpointer user_data )
{
    g_print ( "on_user_prefrences1_activate : called\n" );
}
void on_current_traffic_activate ( GtkWidget *widget, gpointer user_data )
{
    g_print ( "on_current_traffic_activate : called\n" );
}
void on_contact_prefrences1_activate ( GtkWidget *widget, gpointer user_data )
{
    g_print ( "on_contact_prefrences1_activate : called\n" );
}

void on_transmit_threshold1_activate ( GtkWidget *widget, gpointer user_data )
{
    run_threshhold_dialog();
}

void on_EditContactButton_clicked (GtkWidget *widget, gpointer user_data)
{
	run_editcontact_window( widget, user_data);
}
