/*  gtkcutlass-passphrasewindow - handle the passphrase entry window and
*  associated callbacks.
*
*  23/08/2004 - Finland (some hotel near the airport)
*/

#include <gtkcutlass.h>

gint passphrasestatus = 0;

gchar *run_passphrase_dialog ( void )
{
    GtkWidget * dialog;
    GtkWidget *Main;
    GtkWidget *entry;
    GtkWidget *hbox;
    gchar *password = NULL;
    extern gui_status *currentstatus;

    Main = glade_xml_get_widget ( currentstatus->MainWinXML, "GTKCutlassMainWin" );

    dialog = gtk_message_dialog_new ( GTK_WINDOW( Main ), GTK_DIALOG_DESTROY_WITH_PARENT,
                                      GTK_MESSAGE_QUESTION,
                                      GTK_BUTTONS_OK_CANCEL,
                                      "Please Enter Key Passphrase" );

    entry = gtk_entry_new();
    gtk_entry_set_visibility ( GTK_ENTRY( entry ), FALSE );
    gtk_widget_show ( entry );
    g_signal_connect ( entry, "activate", G_CALLBACK( on_passphrasewindow_passphrase_entry_activate ), dialog );

    hbox = gtk_hbox_new ( FALSE, 0 );
    gtk_widget_show ( hbox );

    gtk_box_pack_start ( GTK_BOX( hbox ), GTK_WIDGET( entry ), TRUE, TRUE, 4 );
    gtk_box_pack_start ( GTK_BOX( GTK_DIALOG( dialog ) ->vbox ), hbox, FALSE, TRUE, 4 );

    gtk_dialog_set_default_response( GTK_DIALOG( dialog ), GTK_RESPONSE_OK );

    if ( gtk_dialog_run ( GTK_DIALOG( dialog ) ) == GTK_RESPONSE_OK )
        password = g_strndup ( gtk_entry_get_text( GTK_ENTRY( entry ) ), GTKC_PASS_MAX );
    else
        password = NULL;

    gtk_widget_destroy ( dialog );
    return ( password );
}


void on_passphrasewindow_cancel_button_activate ( GtkWidget *widget, gpointer user_data )
{
    tellem( "Key passphrase is required. " );
    passphrasestatus = 1;
    gtk_widget_destroy ( gtk_widget_get_toplevel( widget ) );
}

void on_passphrasewindow_passphrase_entry_activate ( GtkWidget *widget, gpointer user_data )
{
    extern user_info * userstuff;
    gchar *tmpbuffer;

    if ( widget == NULL )
        return ;

    tmpbuffer = ( gchar * ) gtk_entry_get_text ( ( GtkEntry * ) widget );
    if ( tmpbuffer == NULL )
        g_error ( "Error loading text from passphrase entry\n" );

    if ( g_utf8_strlen( tmpbuffer, GTKC_PASS_MAX ) <= 0 )
        g_error ( "Odd issues with passphrase length" );

    userstuff->key_passphrase = g_strndup( tmpbuffer, GTKC_PASS_MAX );
    gtk_dialog_response ( GTK_DIALOG( gtk_widget_get_toplevel( widget ) ), GTK_RESPONSE_OK );
}

